function init():void {
	//xml			
	if(o){Output.trace("Loading XML");};
	loader = new URLLoader();
	loader.load(new URLRequest(url));
	loader.addEventListener(Event.COMPLETE, onCompleteXML);	
}


function onCompleteXML(event:Event):void{
	text_xml = new XML(loader.data);
	if(o){Output.trace("XML loaded, loading 3D");};
	init3d();
}

function init3d():void {	
	//3d
	camera.zoom = text_xml.options[0].@zoom;
	camera.focus = text_xml.options[0].@focus;
	addChild(view);
	theLight = new PointLight3D(true);
	theLight.x = -200;
	theLight.y = -200;
	theLight.z = 200;
	theLight2 = new PointLight3D(true);
	theLight2.x = 200;
	theLight2.y = 200;
	theLight2.z = -200;
	
	
	fx = new EffectLayer();
   	view.addRenderLayer(fx);
	
	split_offset = 0;
	i = 0;
	obj = new Array();
	for(xx=0; xx<text_xml.letter.length(); xx++)
	{
		for(yy=0; yy<text_xml.letter[xx].row.length(); yy++){
			var my_split:Array = text_xml.letter[xx].row[yy].split("");    
			
			for(zz=0; zz<my_split.length; zz++)
			{
				if(my_split[zz] == "x")
				{
					//material													
					var ml:MaterialsList = new MaterialsList();
					var mat:MaterialObject3D = new MaterialObject3D();
					switch(String(text_xml.letter[xx].@mtype))
					{
						case "wireframe":									
							mat = new WireframeMaterial(Number("0x"+text_xml.letter[xx].@color), 50, 1);	
							ml.addMaterial(mat, "all");
							break;
						case "solid":															
							mat = new ColorMaterial(Number("0x"+text_xml.letter[xx].@color));	
							ml.addMaterial(mat, "all");
							break;
						case "phong":															
							mat = new PhongMaterial(theLight, 0xFFFFFF, Number("0x"+text_xml.letter[xx].@color), 0x000000);
							ml.addMaterial(mat, "all");
							break;
						case "gouraud":															
							mat = new GouraudMaterial(theLight2, 0xFFFFFF, Number("0x"+text_xml.letter[xx].@color));
							ml.addMaterial(mat, "all");
							break;
						case "flat":															
							mat = new FlatShadeMaterial(theLight2, 0xFFFFFF, Number("0x"+text_xml.letter[xx].@color));
							ml.addMaterial(mat, "all");
							break;
						case "cell":															
							mat = new CellMaterial(theLight2, 0xFFFFFF, Number("0x"+text_xml.letter[xx].@color), 6);
							ml.addMaterial(mat, "all");
							break;
						case "bitmap":															
							mat = new BitmapFileMaterial(text_xml.letter[xx].@src);
							ml.addMaterial(mat, "all");
							break;
						default:
							break;
					}
					
					//shape variables
					var my_size:Number =10* Number(text_xml.letter[xx].@size_mod); 
					var my_x:Number = ((yy*10 * -1)+Number(text_xml.options[0].@mod_x))*Number(text_xml.options[0].@spacing_mod);
					var my_y:Number = ((zz+split_offset)*10 +Number(text_xml.options[0].@mod_y))*Number(text_xml.options[0].@spacing_mod);
					
					//shapes
					switch(String(text_xml.letter[xx].@shape))
					{
						case "square":
							obj[i] = new Cube(
		        				ml,
		        				my_size,
		        				my_size,
		        				my_size,
		        				1*Number(text_xml.letter[xx].@poly_mod),
		        				1*Number(text_xml.letter[xx].@poly_mod),
		        				1*Number(text_xml.letter[xx].@poly_mod),
		        				0,
		        				0,
		        				{
			        				y: my_x,
			        				x: my_y
			        			}
			        		);
							break;
						case "sphere":
							obj[i] = new Sphere(
		        				mat,
		        				my_size,
		        				8*Number(text_xml.letter[xx].@poly_mod),
		        				6*Number(text_xml.letter[xx].@poly_mod),
		        				{
			        				y: my_x,
			        				x: my_y
			        			}
			        		);
							break;
						case "cylinder":
							obj[i] = new Cylinder(
		        				mat,
		        				my_size,
		        				my_size,
		        				8*Number(text_xml.letter[xx].@poly_mod),
		        				6*Number(text_xml.letter[xx].@poly_mod),
		        				my_size,
		        				{
			        				y: my_x,
			        				x: my_y
			        			}
			        		);
							break;
						case "cone":
							obj[i] = new Cone(
		        				mat,
		        				my_size,
		        				my_size,
		        				8*Number(text_xml.letter[xx].@poly_mod),
		        				6*Number(text_xml.letter[xx].@poly_mod),
		        				{
			        				y: my_x,
			        				x: my_y
			        			}
			        		);
							break;
						default:
							break;
					}
					i++;
    			}						
			}
    	}
    	split_offset += my_split.length;
	}
	for(i=0; i<obj.length; i++)
	{
		scene.addChild(obj[i]);
	}
	
    addEventListener( Event.ENTER_FRAME, enterFrameHandler );   

}

function enterFrameHandler( event : Event ):void {
	var temp:LayerEffect;
	var temp2:LayerEffect;
	var d:Number;
	for(i=0; i<obj.length; i++)
	{
		d = (obj[i].distanceTo(camera)/4000);
		if(text_xml.options[0].@depth_blur == "true" && text_xml.options[0].@white_out == "false")
		{        		
			fx.removeEffect(temp);
			temp=new LayerEffect(new BlurFilter(10*d, 10*d, 1));
			fx.addEffect(temp);
		}
		else if(text_xml.options[0].@depth_blur == "false" && text_xml.options[0].@white_out == "true")
		{
			fx.removeEffect(temp2);
	    	temp2=new LayerEffect(new GlowFilter(0xffffff, d, 10*d, 10*2, 10*d, 1, true, false));
			fx.addEffect(temp2);
		}
		else if(text_xml.options[0].@depth_blur == "true" && text_xml.options[0].@white_out == "true")
		{
			fx.removeEffect(temp);
			fx.removeEffect(temp2);
			temp=new LayerEffect(new BlurFilter(10*d, 10*d, 1));
			temp2=new LayerEffect(new GlowFilter(0xffffff, d, 10*d, 10*2, 10*d, 1, true, false));
			fx.addEffect(temp);
			fx.addEffect(temp2);
		
	    	
		}
		obj[i].renderLayer = fx;		   
	}

	camera.hover(1, view.containerSprite.mouseX/50, view.containerSprite.mouseY/50);            
	renderer.renderScene(scene, camera, view);

	if(o){Output.trace("heartbeat");};
}